<?php


namespace App\Services;

use App\Services\BaseService;
use App\Models\GameplayRule;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Collection;
use Illuminate\Support\Facades\Cache;
use Illuminate\Support\Facades\Log;
use App\Services\BalanceLogService;
use App\Constants\GameplayRuleEnum;

/**
 * 玩法规则服务类
 */
class GameplayRuleService extends BaseService
{
    const CACHE_KEY = 'gameplay_rules_';

    /**
     * @description: 模型
     * @return {string}
     */
    public static function model(): string
    {
        return GameplayRule::class;
    }

    /**
     * @description: 枚举
     * @return {*}
     */
    public static function enum(): string
    {
        return GameplayRuleEnum::class;
    }

    /**
     * @description: 获取查询条件
     * @param {array} $search 查询内容
     * @return {array}
     */
    public static function getWhere(array $search = []): array
    {
        $where = [];
        if (isset($search['groups']) && !empty($search['groups'])) {
            $where[] = ['groups', '=', $search['groups']];
        }
        if (isset($search['keywords']) && !empty($search['keywords'])) {
            $where[] = ['keywords', '=', $search['keywords']];
        }
        if (isset($search['id']) && !empty($search['id'])) {
            $where[] = ['id', '=', $search['id']];
        }

        return $where;
    }

    /**
     * @description: 查询单条数据
     * @param array $search
     * @return \App\Models\Coin|null
     */
    public static function findOne(array $search): ?GameplayRule
    {
        return self::model()::where(self::getWhere($search))->first();
    }

    /**
     * @description: 查询所有数据
     * @param array $search
     * @return \Illuminate\Database\Eloquent\Collection
     */
    public static function findAll(array $search = [])
    {
        return self::model()::where(self::getWhere($search))->get();
    }

    /**
     * @description: 分页查询
     * @param array $search
     * @return \Illuminate\Contracts\Pagination\LengthAwarePaginator
     */
    public static function paginate(array $search = [])
    {
        $limit = isset($search['limit']) ? $search['limit'] : 15;
        $paginator = self::model()::where(self::getWhere($search))->paginate($limit);
        return ['total' => $paginator->total(), 'data' => $paginator->items()];
    }

    /**
     * @description:
     * @param {*} $params
     * @return {*}
     */
    public static function submit($params = [])
    {
        $result = false;
        $msg['code'] = self::NOT;
        $msg['msg'] = '';

        // 2. 判断是否是更新
        if (!empty($params['id'])) {
            // 更新
            $info = self::findOne(['id' => $params['id']]);
            if (!$info) {
                $msg['msg'] = '规则不存在！';
            } else {
                $result = $info->update($params);
                $id = $params['id'];
            }

        } else {
            // 创建
            $result = $info = self::model()::create($params);
            $id = $result->id;
        }


        if ($result) {
            self::clearCache($params['keywords']);
            $msg['code'] = self::YES;
            $msg['msg'] = '设置成功';
        } else {
            $msg['msg'] = empty($msg['msg']) ? '操作失败' : $msg['msg'];
        }

        return $msg;
    }

    /**
     * @description: 获取玩法规则
     * @param string $keywords
     * @return *
     */
    public static function getGameplayRules($keywords)
    {
        $cacheKey = self::CACHE_KEY . $keywords;
        if (Cache::has($cacheKey)) {
            return Cache::get($cacheKey);
        }

        $rules = self::model()::where('keywords', $keywords)->first();
        if (!$rules) {
            return null;
        }

        $rulesArray = $rules->toArray();
        Cache::put($cacheKey, $rulesArray, 3600); // 缓存1小时

        return $rulesArray;
    }

    /**
     * @description: 清除缓存
     * @param string $keywords
     * @return void
     */
    public static function clearCache($keywords)
    {
        $cacheKey = self::CACHE_KEY . $keywords;
        Cache::forget($cacheKey);
    }

    /**
     * @description: 校验输入的内容
     * @param {*} $input
     * @return {*}
     */
    public static function bettingRuleVerify($input)
    {
        $input = explode(' ', $input);
        $result = [];
        foreach ($input as $value) {
            $res = self::validateInput($value);
            if ($res !== null) {
                $result[] = $res;
            }
        }
        if (empty($result)) return null;
        return $result;
    }

    /**
     * @description: 校验输入的内容
     * @param {*} $input
     * @return {*}
     */
    public static function validateInput($input)
    {
        // 获取所有玩法
        $allRules = self::model()::pluck('keywords')->toArray();

        // 玩法正则（防止玩法里有特殊符号出错）
        $rulesPattern = implode('|', array_map('preg_quote', $allRules));

        // 匹配玩法 + 金额
        if (preg_match('/^(' . $rulesPattern . ')(\d+)$/u', $input, $matches)) {
            return [
                'rule' => $matches[1],
                'amount' => (int)$matches[2]
            ];
        }

        return null;
    }
}